
package magercises.barrier.solution;


import java.awt.*;
import java.applet.Applet;

class MasterCounter  {
  static MasterCounter instance;
  int countOfCounters = 0;
  int countersWaiting = 0;
  int totalCount = 0;
  

  protected MasterCounter() { }    
  public synchronized int getTotalCount(int aCurrentCount) {
	totalCount += aCurrentCount;
	if(countersWaiting + 1 == countOfCounters) {
	  notifyAll();
	}
	else {
	  countersWaiting++;
	  try { wait(); }
	  catch (InterruptedException e) { return 0; }
	}
	return totalCount;
  }    
  public static synchronized MasterCounter instance() {
	if(instance == null) 
	  instance = new MasterCounter();
	return instance;
  }    
  public synchronized Counter newCounter(int maxCount, WaitTest a) {
	countOfCounters++;
	return new Counter(maxCount,a);
  }    
}