
package magercises.barrier.solution;


import java.awt.*;
import java.applet.Applet;

public class WaitTest extends Applet {
  TextArea output;
  Counter c1;
  Counter c2;
  Counter c3;


  /** print the string to the output window */
  public synchronized void counterDone(Counter c) {
	output.setText(output.getText()
		   +  c.toString());
  }    
  public void init() {
	// create a TextArea for output
	setLayout(new FlowLayout());
	add(output = new TextArea(5,40));
  }    
  public void start() {
	// create new master and counters
	c1 = MasterCounter.instance().newCounter(5,this);
	c2 = MasterCounter.instance().newCounter(10,this);
	c3 = MasterCounter.instance().newCounter(15,this);

	// start counters going
	c1.start();
	c2.start();
	c3.start();
  }    
}