
package magercises.meta.solution;

// Copyright 1996, <a href=http://www.MageLang.com>MageLang Institute</a>.

import java.util.Vector;
import java.util.Enumeration;


class Company extends NamedEntity implements Client {
  int contrAmt = 0;
  Vector clients = new Vector(10);


  public Company(String aName) {
	super(aName);
  }    
  public void addClient(Client c) {
	clients.addElement(c);	
  }    
  public int contractAmount() {
	return contrAmt;
  }    
  public String contractDescription() {
	return "Company " + getName() + 
	  " contract for " + contractAmount() + " ";
  }    
  public String contractListing() {
	StringBuffer buff = new StringBuffer(200);
	Client aClient;
	Enumeration enum = clients.elements();
	while(enum.hasMoreElements()) {
	  aClient = (Client)enum.nextElement();
	  buff.append(aClient.contractDescription() + "\n");
	}
	return buff.toString();
  }    
  public void SetContractAmount(int amount) {
	contrAmt = amount;
  }    
  /** return the total value of all contracts with Persons */
  public int totalIndividualContracts() {
	int total = 0;
	Client aClient;
	Enumeration enum = clients.elements();
	while(enum.hasMoreElements()) {
	  aClient = (Client)enum.nextElement();
	  if(aClient.getClass().getName().equals("Person"))
	total += aClient.contractAmount();
	}
	return total;
  }    
}