
package magercises.primitives.solution;

// Copyright 1996, <a href=http://www.MageLang.com>MageLang Institute</a>.

import java.io.*;

public class Primitives {

	public static void main(String[] args) throws IOException {
		FileOutputStream f = null;
		DataOutputStream df = null;

		// make a generic output byte stream
		f = new FileOutputStream("junk");
		// attach a DataOutputStream to it so we can write more complex items
		df = new DataOutputStream(f);
		df.writeInt(34);
		df.writeChars("hello");
		df.writeDouble(3.14159);
		df.writeByte(2);
		df.close(); // close and free up system resource.

		// now, open it back up and read it all back in
		FileInputStream fin = new FileInputStream("junk");
		DataInputStream di = new DataInputStream(fin);
		int i = di.readInt();
		char[] c = new char[5];
		for (int j=0; j<5; j++) {
			c[j] = di.readChar();
		}
		String s = String.valueOf(c);
		double ff = di.readDouble();
		byte b = di.readByte();
		di.close();

		// test the results
		if ( i==34 ) System.out.println("readInt ok");
		else System.out.println("readInt not ok");
		if ( s.equals("hello") ) System.out.println("readChar ok");
		else System.out.println("readChar not ok");
		if ( ff==3.14159 ) System.out.println("readFloat ok");
		else System.out.println("readFloat not ok");
		if ( b==2 ) System.out.println("readByte ok");
		else System.out.println("readByte not ok");
	}
}