
package magercises.syncmethods.solution;


/* 
   Simple use of synch methods to avoid an invalid
   state in an object by serializing access to it,
   in this case, a simple stack.
*/

import java.awt.*;
import java.applet.Applet;
import java.util.Vector;

class StackStuffer extends Thread {
  Object item;
  SimpleStack stack;
  SyncTest syncTestApplet;


  public StackStuffer(Object o, SimpleStack s, SyncTest a) {
	item = o;
	stack = s;
	syncTestApplet = a;
  }    
  public void run() {
	for(int i = 0; i < 10; i++) {
	  stack.push(item);
	}
	for(int i = 0; i < 5; i++) {
	  stack.pop();
	}
	syncTestApplet.threadDone(item);
  }    
}