
package magercises.syncstmt.solution;


/* 
   Simple use of synchronized stmts to avoid an invalid
   state in an object by serializing access to it.

   Given Announce Box and SynchTestApplet, write a 
   Speaker object that uses synch stmts to control
   access to the announcebox.  Demonstrate both
   protected and unprotected access.

*/

import java.awt.*;
import java.applet.Applet;
import java.util.Date;

class Speaker extends Thread {
  AnnounceBox aBox;
  String thingsToSay[];


  public Speaker(AnnounceBox a, String strings[]) {
	aBox = a;
	thingsToSay = strings;
  }    
  public void run() {
	for(int j = 0; j < 5; j++) {
	  synchronized(aBox) {
	for(int i = 0; i < thingsToSay.length; i++) {
	  aBox.announce(thingsToSay[i]);
	}
	  }
	 try{ sleep((int)(Math.random()*50)); }
	 catch (InterruptedException e) { }
	}
	aBox.repaint();

  }    
}