
package magercises.text.solution;

// Copyright 1996, <a href=http://www.MageLang.com>MageLang Institute</a>.

import java.awt.*;
import java.io.*;

public class Text {

	public static void main(String[] args) throws IOException {
		FileOutputStream fo = null;
		PrintStream pf = null;

		// make a generic output byte stream
		fo = new FileOutputStream("junk");
		// attach a PrintStream to it so we can print in text form
		pf = new PrintStream(fo);
		pf.println(34);
		pf.println("an int is " + 34);
		pf.println(3.14159);
		pf.println(true);
		pf.close(); // close and free up system resource.

		// open it back up again
		FileInputStream fi = new FileInputStream("junk");
		DataInputStream di = new DataInputStream(fi);
		String a = di.readLine(); // '\n' not included!!!!!!
		String b = di.readLine();
		String c = di.readLine();
		String d = di.readLine();
		di.close();

		// Convert the strings to primitives
		int i = Integer.parseInt(a);
		float ff = Float.valueOf(c).floatValue();
		boolean bb = Boolean.valueOf(d).booleanValue();

		// verify
		if ( i==34 ) System.out.println("line ok: "+a);
		else System.out.println("line not ok: "+a);
		if ( b.equals("an int is 34") ) System.out.println("line ok: "+b);
		else System.out.println("line not ok: "+b);
		if ( ff == 3.14159 ) System.out.println("line ok: "+c);
		else System.out.println("line not ok: "+c);
		if ( bb ) System.out.println("line ok: "+d);
		else System.out.println("line not ok: "+d);
	}
}