
package magercises.equality.solution;

class Company {
  Employee employees[] = new Employee[3];
  int numEmployees = 0;
  String name;  


  public Company(String aName) {
	name = aName;
  }    
  public void addEmployee(Employee e) {
	if(numEmployees == employees.length) {
	  Employee temp[] = new Employee[employees.length * 2];
	  System.arraycopy(employees, 0, temp, 0, employees.length);
	  employees = temp;
	}
	employees[numEmployees] = e;
	numEmployees++;
  }    
 public Employee findEmployee(Employee e) {
	for(int i = 0; i < numEmployees; i++) {
	  if(employees[i] == e) return e;
	}
	return null;
 }  
 public Employee findEmployeeNamed(String name) {
	for(int i = 0; i < numEmployees; i++) {
	  if(employees[i].name().equals(name)) 
	return employees[i];
	}
	return null;
 }  
  public String toString() {
	StringBuffer buf = new StringBuffer(100);

	buf.append("Company: " + name + "Employees: ");
	for(int i = 0; i < numEmployees; i++) {
	  buf.append(employees[i].toString() + " ");
	}
	return buf.toString();
  }    
}