
package magercises.facade.solution;


/* Using a facade w/ sync methods
   There are two entities with a 1 - 1 relationship, a person
   to a locker,  the registrar object handles reassignment of 
   persons to locker, this avoids potential deadlock.
   (ref. integrity requires that old owner of locker must
   be updated to null)
   (make registration a static method ?)
   how to make live?

*/

import java.awt.*;
import java.applet.Applet;


class Person {
  Locker locker;
  String name;
  

  public Person(String s) {
	name = s;
  }    
  public Locker getLocker() {
	return locker;
  }    
  public String getName() {
	return name;
  }    
  public String toString() { 
	return "Person: " + name + " with locker " 
	  + (locker == null ? "none" : locker.getCode())
	  + "\n";
  }    
}