
package magercises.hash.solution;

// Copyright 1996, <a href=http://www.MageLang.com>MageLang Institute</a>.

import java.util.Hashtable;
import java.util.Enumeration;

class Company {
  Hashtable employees = new Hashtable(10);
  String name;  


  public Company(String aName) {
	name = aName;
  }    
  public void addEmployee(Employee e) {
	employees.put(e,e);
  }    
 public Employee findEmployee(Employee e) {
   return (Employee)employees.get(e);
 }  
 public Employee findEmployeeNamed(String name) {
   Employee e;
   Enumeration enum = employees.elements();
	 while(enum.hasMoreElements()) {
	   e = (Employee)enum.nextElement();
	   if(e.name().equals(name)) 
	 return e;
	 }
   return null;
 }  
  public String toString() {
	StringBuffer buf = new StringBuffer(100);

	buf.append("Company: " + name + " Employees: ");
	Employee e;
	Enumeration enum = employees.elements();
	while(enum.hasMoreElements()) {
	  e = (Employee)enum.nextElement();
	  buf.append(e.toString());
	}
	return buf.toString();
  }    
}