
package magercises.syncmethods.solution;


/* 
   Simple use of synch methods to avoid an invalid
   state in an object by serializing access to it,
   in this case, a simple stack.
*/

import java.awt.*;
import java.applet.Applet;
import java.util.Vector;

public class SyncTest extends Applet {
  TextArea output;
  SimpleStack theStack;


  public void init() {
	setLayout(new FlowLayout());
	add(output = new TextArea(5,50));
  }    
  public void start() {
	theStack = new SimpleStack();
	StackStuffer joe = new StackStuffer("joe",theStack,this);
	StackStuffer bob = new StackStuffer("bob",theStack,this);
	joe.start();
	bob.start();
  }    
  /** print out the state of the stack. */
  public synchronized void threadDone(Object o) {
	output.setText(output.getText()
		   + "StackStuffer" 
		   +  o.toString() + " done, \nstack: " 
		   + theStack.toString() + "\n");
  }    
}